.TH SHARLIT 1 "April 12 1994" "Stanford University" "SUIF Compiler"
.SH NAME
sharlit, nsharlit \- generate data-flow analyzers
.SH SYNOPSIS
.B sharlit
[
.I options
]
.I infile
.SH DESCRIPTION
.I Sharlit
and
.I nsharlit
take descriptions of data-flow analyzers and generate C++ classes to
perform data-flow analysis.  Sharlit uses old SUIF libraries and is
used by oynk to implement its optimization analysis phases, while
nsharlit uses new SUIF libraries and is used by moo to implement its
scalar privatization analysis.
.LP
.I Sharlit
and
.I nsharlit
generate two files:
.B solver.h
and
.BR solver.c .
These files contain the definitions for classes that implement the
data-flow analyzer, the flow functions and flow values.
.LP
Sharlit supports a style of optimization based on a model by Kildall,
in which each phase consists of a data-flow analysis (DFA) of the
program and an optimization function that transforms the program.  To
support the model, a set of abstractions --- flow values, flow
functions, path simplification rules, action routines --- is provided.
Sharlit turns a DFA specifiation consisting of these abstractions into
a solver for a DFA problem.  At the heart of Sharlit is an algorithm
called path simplification, an extension of Tarjan's fast path
algorithm.  Path simplification unifies several powerful DFA solution
techniques.  By using path simplfication rules, compiler writers can
construct a wide range of data-flow analyzers, from simple iterative
ones, to solvers that use local analysis, interval analysis, or sparse
data-flow evaluation.
.LP
For more information, consult the literature listed below.
.SH OPTIONS
.TP
.B -L
This causes Sharlit to generate #line directives for debugging purposes.
.TP
.B -T
causes Sharlit to used a switch-based technique to apply path reduction
rules in place of a parsing-based technique.  The latter technique is
no longer recommended, although some of the older phases of oynk still
use it.
.SH SEE ALSO
.BR oynk (1),
.BR moo (1)
.br
S. Tjiang and J. Hennessy.
Sharlit: A tool for building optimizers.
In
.I
SIGPLAN Conference on Programming Language Design and Implementation,
.ft 1
1992, pp 82-93.
.br
S. Tjiang.
.I
Automatic Generation of Data-flow Analyzers: A tool for building optimizers
.ft 1
Ph.D. Thesis, Stanford University, July 1993.
.SH NOTES
Sharlit needs to be rewritten so that it uses a notation more amenable
to incorporation into C++.
.SH HISTORY
Sharlit and nsharlit were written by Steve Tjiang.
